<!--
    Input:
        vendor_framework_compatibility_matrix.xml
        compatibility_matrix.xml
        compatibility_matrix.xml
        common_compatibility_matrix.xml
        qcom_common_compatibility_matrix.xml
        biometrics_face_compatibility_matrix.xml
        compatibility_matrix_fingerprint.xml
-->
<compatibility-matrix version="2.0" type="framework">
    <hal format="hidl" optional="true">
        <name>android.hardware.automotive.evs</name>
        <version>1.1</version>
        <interface>
            <name>IEvsEnumerator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.gnss</name>
        <version>1.0-1</version>
        <version>2.0-1</version>
        <interface>
            <name>IGnss</name>
            <instance>default</instance>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.media.c2</name>
        <version>1.0</version>
        <interface>
            <name>IComponentStore</name>
            <instance>default</instance>
            <instance>software</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.nfc</name>
        <version>1.0</version>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio</name>
        <version>1.0-4</version>
        <interface>
            <name>IRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio.config</name>
        <version>1.0-1</version>
        <interface>
            <name>IRadioConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.wifi.supplicant</name>
        <version>1.0-2</version>
        <interface>
            <name>ISupplicant</name>
            <instance>default</instance>
            <instance>wigigp2p</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.dsi.ant</name>
        <version>1.0</version>
        <interface>
            <name>IAnt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.dpm.api</name>
        <version>1.0</version>
        <interface>
            <name>IdpmQmi</name>
            <instance>dpmQmiService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.imscmservice</name>
        <version>2.0-2</version>
        <interface>
            <name>IImsCmService</name>
            <instance>qti.ims.connectionmanagerservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.uceservice</name>
        <version>2.0-1</version>
        <version>2.2</version>
        <version>2.3</version>
        <interface>
            <name>IUceService</name>
            <instance>com.qualcomm.qti.uceservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.wifidisplayhal</name>
        <version>1.0</version>
        <interface>
            <name>IDSManager</name>
            <instance>wifidisplaydshal</instance>
        </interface>
        <interface>
            <name>IHDCPSession</name>
            <instance>wifidisplayhdcphal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.quicinc.cne.api</name>
        <version>1.0-1</version>
        <interface>
            <name>IApiService</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.quicinc.cne.server</name>
        <version>2.0-2</version>
        <interface>
            <name>IServer</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.aftersale.hardware.vivoasem</name>
        <version>1.0</version>
        <interface>
            <name>IVivoASEm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.color</name>
        <version>1.0-6</version>
        <interface>
            <name>IDisplayColor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.config</name>
        <version>1.0-15</version>
        <version>2.0</version>
        <interface>
            <name>IDisplayConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.postproc</name>
        <version>1.0</version>
        <interface>
            <name>IDisplayPostproc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.factory.hardware.vivoem</name>
        <version>1.0</version>
        <interface>
            <name>IVivoEm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.hardware.nfc</name>
        <version>1.0-1</version>
        <version>2.0</version>
        <interface>
            <name>INqNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.nxpnfclegacy</name>
        <version>1.0</version>
        <interface>
            <name>INxpNfcLegacy</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.automotive.qcarcam</name>
        <version>1.0</version>
        <interface>
            <name>IQcarCamera</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.data.factory</name>
        <version>1.0</version>
        <version>2.0-3</version>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.diaghal</name>
        <version>1.0</version>
        <interface>
            <name>Idiag</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.esepowermanager</name>
        <version>1.0-1</version>
        <interface>
            <name>IEsePowerManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.gnss</name>
        <version>1.0-2</version>
        <version>2.0-1</version>
        <version>3.0</version>
        <version>4.0-1</version>
        <interface>
            <name>ILocHidlGnss</name>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.AGMIPC</name>
        <version>1.0</version>
        <interface>
            <name>IAGM</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.alarm</name>
        <version>1.0</version>
        <interface>
            <name>IAlarm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.audiohalext</name>
        <version>1.0</version>
        <interface>
            <name>IAudioHalExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.bluetooth_audio</name>
        <version>2.0-1</version>
        <interface>
            <name>IBluetoothAudioProvidersFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.bluetooth_sar</name>
        <version>1.0-1</version>
        <interface>
            <name>IBluetoothSar</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.btconfigstore</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>IBTConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cacert</name>
        <version>1.0</version>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.camera.postproc</name>
        <version>1.0</version>
        <interface>
            <name>IPostProcService</name>
            <instance>camerapostprocservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.capabilityconfigstore</name>
        <version>1.0</version>
        <interface>
            <name>ICapabilityConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cryptfshw</name>
        <version>1.0</version>
        <interface>
            <name>ICryptfsHw</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.cvp</name>
        <version>1.0</version>
        <interface>
            <name>ICvp</name>
            <instance>cvphalservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.connection</name>
        <version>1.0-1</version>
        <interface>
            <name>IDataConnection</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.iwlan</name>
        <version>1.0</version>
        <interface>
            <name>IIWlan</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.latency</name>
        <version>1.0</version>
        <interface>
            <name>ILinkLatency</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.debugutils</name>
        <version>1.0</version>
        <interface>
            <name>IDebugUtils</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.allocator</name>
        <version>1.0</version>
        <version>3.0</version>
        <version>4.0</version>
        <interface>
            <name>IQtiAllocator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.composer</name>
        <version>2.0-1</version>
        <version>3.0</version>
        <interface>
            <name>IQtiComposer</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.demura</name>
        <version>1.0</version>
        <version>2.0</version>
        <interface>
            <name>IDemuraFileFinder</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.display.mapper</name>
        <version>2.0</version>
        <version>3.0</version>
        <version>4.0</version>
        <interface>
            <name>IQtiMapper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.dsp</name>
        <version>1.0</version>
        <interface>
            <name>IDspService</name>
            <instance>dspservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.eid</name>
        <version>1.0</version>
        <interface>
            <name>IEid</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.embmssl</name>
        <version>1.0-1</version>
        <interface>
            <name>IEmbms</name>
            <instance>embmsslServer0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.factory</name>
        <version>1.0-1</version>
        <interface>
            <name>IFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fingerprint</name>
        <version>1.0</version>
        <interface>
            <name>IQtiExtendedFingerprint</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fm</name>
        <version>1.0</version>
        <interface>
            <name>IFmHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fstman</name>
        <version>1.0</version>
        <interface>
            <name>IFstManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.iop</name>
        <version>2.0</version>
        <interface>
            <name>IIop</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.limits</name>
        <version>1.0</version>
        <interface>
            <name>ILimits</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.mwqemadapter</name>
        <version>1.0</version>
        <interface>
            <name>IMwqemAdapter</name>
            <instance>MwqemAdapter</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.pal</name>
        <version>1.0</version>
        <interface>
            <name>IPAL</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qccsyshal</name>
        <version>1.0</version>
        <interface>
            <name>IQccsyshal</name>
            <instance>qccsyshal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qccvndhal</name>
        <version>1.0</version>
        <interface>
            <name>IQccvndhal</name>
            <instance>qccvndhal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qconfig</name>
        <version>1.0</version>
        <interface>
            <name>IQConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qdutils_disp</name>
        <version>1.0</version>
        <interface>
            <name>IQdutilsDisp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qseecom</name>
        <version>1.0</version>
        <interface>
            <name>IQSEECom</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qteeconnector</name>
        <version>1.0</version>
        <interface>
            <name>IAppConnector</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IGPAppConnector</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRCoreService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRCamService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRSplitService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRModService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.qti.hardware.qxr</name>
        <interface>
            <name>IQXRAudioService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.am</name>
        <version>1.0</version>
        <interface>
            <name>IQcRilAudio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.ims</name>
        <version>1.0-7</version>
        <interface>
            <name>IImsRadio</name>
            <instance>imsradio0</instance>
            <instance>imsradio1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.internal.deviceinfo</name>
        <version>1.0</version>
        <interface>
            <name>IDeviceInfo</name>
            <instance>deviceinfo</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.lpa</name>
        <version>1.0-2</version>
        <interface>
            <name>IUimLpa</name>
            <instance>UimLpa0</instance>
            <instance>UimLpa1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qcrilhook</name>
        <version>1.0</version>
        <interface>
            <name>IQtiOemHook</name>
            <instance>oemhook0</instance>
            <instance>oemhook1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradio</name>
        <version>1.0</version>
        <version>2.0-6</version>
        <interface>
            <name>IQtiRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim</name>
        <version>1.1-2</version>
        <interface>
            <name>IUim</name>
            <instance>Uim0</instance>
            <instance>Uim1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_client</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceClient</name>
            <instance>uimRemoteClient0</instance>
            <instance>uimRemoteClient1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_server</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceServer</name>
            <instance>uimRemoteServer0</instance>
            <instance>uimRemoteServer1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.scve.objecttracker</name>
        <version>1.0</version>
        <interface>
            <name>IObjectTracker</name>
            <instance>objectTracker</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.scve.panorama</name>
        <version>1.0</version>
        <interface>
            <name>IPanoramaStitching</name>
            <instance>panoStitching</instance>
        </interface>
        <interface>
            <name>IPanoramaTracking</name>
            <instance>panoTracking</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.seccam</name>
        <version>1.0</version>
        <interface>
            <name>ISecCam</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.secureprocessor.device</name>
        <version>1.0</version>
        <interface>
            <name>ISecureProcessor</name>
            <instance>qti-tee</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.sensorscalibrate</name>
        <version>1.0</version>
        <interface>
            <name>ISensorsCalibrate</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.servicetracker</name>
        <version>1.0-2</version>
        <interface>
            <name>IServicetracker</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.slmadapter</name>
        <version>1.0</version>
        <interface>
            <name>ISlmAdapter</name>
            <instance>SlmAdapter</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.soter</name>
        <version>1.0</version>
        <interface>
            <name>ISoter</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.sxrhal</name>
        <version>1.0</version>
        <interface>
            <name>ISxrCrypto</name>
            <instance>sxrhalservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.systemhelper</name>
        <version>1.0</version>
        <interface>
            <name>ISystemEvent</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>ISystemResource</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.trustedui</name>
        <version>1.0-2</version>
        <interface>
            <name>ITrustedInput</name>
            <instance>default</instance>
            <instance>qtee-vm</instance>
        </interface>
        <interface>
            <name>ITrustedUI</name>
            <instance>default</instance>
            <instance>qtee-vm</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.tui_comm</name>
        <version>1.0</version>
        <interface>
            <name>ITuiComm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.vpp</name>
        <version>1.1-3</version>
        <version>2.0</version>
        <interface>
            <name>IHidlVppService</name>
            <instance>vppService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.hostapd</name>
        <version>1.0-3</version>
        <interface>
            <name>IHostapdVendor</name>
            <instance>default</instance>
            <instance>wigighostapd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.supplicant</name>
        <version>2.0-3</version>
        <interface>
            <name>ISupplicantVendor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wificfr</name>
        <version>1.0</version>
        <interface>
            <name>IWificfr</name>
            <instance>wificfr</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifilearner</name>
        <version>1.0</version>
        <interface>
            <name>IWifiStats</name>
            <instance>wifiStats</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifi.wifimyftm</name>
        <version>1.0</version>
        <interface>
            <name>IWifiMyFtm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wifidisplaysession</name>
        <version>1.0</version>
        <interface>
            <name>IWifiDisplaySession</name>
            <instance>wifidisplaysession</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionAudioTrack</name>
            <instance>wifidisplaysessionaudiotrack</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionImageTrack</name>
            <instance>wifidisplaysessionimagetrack</instance>
        </interface>
        <interface>
            <name>IWifiDisplaySessionVideoTrack</name>
            <instance>wifidisplaysessionvideotrack</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wigig.netperftuner</name>
        <version>1.0</version>
        <interface>
            <name>INetPerfTuner</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wigig.supptunnel</name>
        <version>1.0</version>
        <interface>
            <name>ISuppTunnelProvider</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.wipower</name>
        <version>1.0</version>
        <interface>
            <name>IWipower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.ims.callinfo</name>
        <version>1.0</version>
        <interface>
            <name>IService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.ims.factory</name>
        <version>1.0-1</version>
        <interface>
            <name>IImsFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.imsrtpservice</name>
        <version>3.0</version>
        <interface>
            <name>IRTPService</name>
            <instance>imsrtpservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.memory.pasrmanager</name>
        <version>1.0-1</version>
        <interface>
            <name>IPasrManager</name>
            <instance>pasrhal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.power.pasrmanager</name>
        <version>1.0</version>
        <interface>
            <name>IPasrManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.qesdhal</name>
        <version>1.0-1</version>
        <interface>
            <name>IQesdhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.qspmhal</name>
        <version>1.0</version>
        <interface>
            <name>IQspmhal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.spu</name>
        <version>1.0-1</version>
        <interface>
            <name>ISPUManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.voiceprint</name>
        <version>1.0</version>
        <interface>
            <name>IQtiVoicePrintService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.bbkts</name>
        <version>1.0</version>
        <interface>
            <name>IBbkts</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.vivo.hardware.biometrics.analysis</name>
        <version>1.1</version>
        <interface>
            <name>IAnalysis</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.biometrics.face</name>
        <version>2.0</version>
        <interface>
            <name>IBiometricsFace</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.vivo.hardware.biometrics.fingerprint</name>
        <version>3.0</version>
        <interface>
            <name>IBiometricsFingerprintExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="aidl" optional="true">
        <name>vendor.vivo.hardware.bspservice</name>
        <interface>
            <name>IBSPService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.camera3rd.provider</name>
        <version>1.0</version>
        <interface>
            <name>ICamera3rdProvider</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.capacity_key</name>
        <version>1.0</version>
        <interface>
            <name>ICapacityKey</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.configstore</name>
        <version>1.0</version>
        <interface>
            <name>IVivoConfigStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.dualleds</name>
        <version>1.0</version>
        <interface>
            <name>IDualleds</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.eid</name>
        <version>1.0</version>
        <interface>
            <name>IEidDevice</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.lcmctl</name>
        <version>1.0</version>
        <interface>
            <name>ILcmCtl</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.omnipotentservice</name>
        <version>1.0</version>
        <interface>
            <name>IOmnipotentService</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.vivo.hardware.sectee</name>
        <version>1.0</version>
        <interface>
            <name>ISecTee</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.sensorfactory</name>
        <version>1.0</version>
        <interface>
            <name>ISensorFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.vivo.hardware.slad</name>
        <version>1.0</version>
        <interface>
            <name>ISlad</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.vcode</name>
        <version>1.0</version>
        <interface>
            <name>IEventTransfer</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IVcode</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.vivo.hardware.vcustom</name>
        <version>1.0</version>
        <interface>
            <name>ICustom</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.vdtf</name>
        <version>1.0</version>
        <interface>
            <name>IVdtf</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.vibrator_hall</name>
        <version>1.0</version>
        <interface>
            <name>IVib_Hall</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.vpad_bbkts</name>
        <version>1.0</version>
        <interface>
            <name>IVpadbbkts</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.vperf</name>
        <version>1.0</version>
        <interface>
            <name>IVPerf</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.wifi.hostapd</name>
        <version>1.0</version>
        <interface>
            <name>IVivoHostapd</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.wifi.keystore</name>
        <version>1.0</version>
        <interface>
            <name>IKeystoreExt</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.vivo.hardware.wifi.wifivendorsta</name>
        <version>1.0</version>
        <interface>
            <name>IVivoWifiVendorStaIface</name>
            <instance>default</instance>
        </interface>
    </hal>
    <sepolicy>
        <kernel-sepolicy-version>30</kernel-sepolicy-version>
        <sepolicy-version>26.0</sepolicy-version>
        <sepolicy-version>27.0</sepolicy-version>
        <sepolicy-version>28.0</sepolicy-version>
        <sepolicy-version>29.0</sepolicy-version>
        <sepolicy-version>30.0</sepolicy-version>
    </sepolicy>
    <avb>
        <vbmeta-version>1.0</vbmeta-version>
    </avb>
</compatibility-matrix>
